summaryrefslogtreecommitdiff
path: root/tests/misc/date-sec
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/date-sec')
-rwxr-xr-xtests/misc/date-sec67
1 files changed, 67 insertions, 0 deletions
diff --git a/tests/misc/date-sec b/tests/misc/date-sec
new file mode 100755
index 0000000..6852c87
--- /dev/null
+++ b/tests/misc/date-sec
@@ -0,0 +1,67 @@
+#!/bin/sh
+# Ensure that a command like
+# `date --date="21:04 +0100" +%S' always prints `00'.
+# Before coreutils-5.2.1, it would print the seconds from the current time.
+
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ date --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# It would be easier simply to sleep for two seconds between two runs
+# of `date --date="21:04 +0100" +%S` and ensure that both outputs
+# are `00', but I prefer not to sleep unconditionally. `make check'
+# takes long enough as it is.
+
+n=0
+# See if the current number of seconds is `00' or just before.
+s=`date +%S`
+case "$s" in
+ 58) n=3;;
+ 59) n=2;;
+ 00) n=1;;
+esac
+
+# If necessary, wait for the system clock to pass the minute mark.
+test $n = 0 || sleep $n
+
+s=`date --date="21:04 +0100" +%S`
+case "$s" in
+ 00) ;;
+ *) fail=1;;
+esac
+
+(exit $fail); exit $fail